package ccws2024.workshop1.view.managedbeans;

import java.io.Serializable;

import org.eclnt.editor.annotations.CCGenClass;
import org.eclnt.jsfserver.defaultscreens.ISetId;
import org.eclnt.jsfserver.defaultscreens.IdTextSelection;
import org.eclnt.jsfserver.elements.events.BaseActionEventValueHelp;
import org.eclnt.jsfserver.pagebean.PageBean;

import ccws2024.workshop1.logic.DOPerson;

@CCGenClass (expressionBase="#{d.PersondetailUI}")

public class PersondetailUI
    extends PageBean 
    implements Serializable
{
    public void onDepartmentAction(javax.faces.event.ActionEvent event) 
    {
        if (event instanceof BaseActionEventValueHelp)
        {
            IdTextSelection idts = IdTextSelection.createInstance();
            idts.addLine("SALES","Vertrieb");
            idts.addLine("DEV","Entwicklung");
            idts.setCallBack(new ISetId()
            {
                @Override
                public void setId(String id)
                {
                    m_person.setDepartment(id);
                }
            });
            idts.setRenderFilterText(true);
        }
    }

    public void onSaveAction(javax.faces.event.ActionEvent event) 
    {
        // ...
        // ...
        if (m_listener != null)
            m_listener.reactOnSaved(m_person);
    }

    DOPerson m_person;
    public DOPerson getPerson() { return m_person; }

    // ------------------------------------------------------------------------
    // inner classes
    // ------------------------------------------------------------------------
    
    public interface IListener extends Serializable
    {
        public void reactOnSaved(DOPerson person);
    }
    
    // ------------------------------------------------------------------------
    // members
    // ------------------------------------------------------------------------
    
    private IListener m_listener;
    
    // ------------------------------------------------------------------------
    // constructors & initialization
    // ------------------------------------------------------------------------

    public PersondetailUI()
    {
        // m_person = Logic.readPerson("10");
    }

    public String getPageName() { return "/layouts/persondetail.xml"; }
    public String getRootExpressionUsedInPage() { return "#{d.PersondetailUI}"; }

    // ------------------------------------------------------------------------
    // public usage
    // ------------------------------------------------------------------------

    public void prepare(DOPerson person, IListener listener)
    {
        m_person = person;
        m_listener = listener;
    }

    // ------------------------------------------------------------------------
    // private usage
    // ------------------------------------------------------------------------
}
